models/Museum.php
<?php

namespace app\models;

use yii;
use yii\helpers\ArrayHelper;
use app\common\components\ActiveRecord\ActiveRecord;
use yii\behaviors\TimestampBehavior;

/**
 * This is the model class for table "museums".
 *
 * @property integer $id
 * @property string $name
 * @property integer $statusId
 * @property integer $expertId
 * @property string $comment
 * @property string $contacts
 * @property File $lastFileId
 * @property integer $additional
 *
 * @property File[] $files
 * @property Status $status
 * @property MuseumStatus $lastMStatus
 * @property MuseumStatus[] $mStatuses
 * @property User $expert
 */
class Museum extends ActiveRecord
{

	public function behaviors()
	{
		return [
			TimestampBehavior::className(),
		];
	}

    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'museums';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['name'], 'required','message'=>'Поле {attribute} необходимо для заполнения'],
            [['statusId', 'expertId', 'additional'], 'integer','message'=>'Поле {attribute} должно быть целым числом'],
            [['comment'], 'string','message'=>'Комментарий должен быть строкой'],
            [['name'], 'string', 'max' => 255, 'message'=>'Длинна имени ограничена 255 символами'],
            [['contacts'], 'string', 'max' => 512, 'message'=>'Длинна имени ограничена 512 символами'],
            [['statusId'], 'exist', 'skipOnError' => true, 'targetClass' => Status::className(), 'targetAttribute' => ['statusId' => 'id'], 'message'=>'Некорретный статус'],
            [['expertId'], 'exist', 'skipOnError' => true, 'targetClass' => User::className(), 'targetAttribute' => ['expertId' => 'id'], 'message'=>'Некорректный эксперт'],
	        [['lastFileId'], 'exist', 'skipOnError' => false, 'targetClass' => File::className(), 'targetAttribute' => ['lastFileId' => 'id'], 'message'=>'Некорректный файл'],
	        [['statusId', 'expertId','lastFileId'],'filter','filter'=>function($value){return $value==''?null:intval($value);}]
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Имя',
            'statusId' => 'Статус',
            'expertId' => 'Эксперт',
            'comment' => 'Комментарий',
            'contacts' => 'Контакты',
            'lastFileId' => 'Крайний файл',
	        'created_at' => 'Создано',
	        'updated_at' => 'Обновлено',
	        'additional' => 'Доп. инфо',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getFiles()
    {
        return $this->hasMany(File::className(), ['museumId' => 'id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getLastFile()
    {
        return $this->hasOne(File::className(), ['id' => 'lastFileId']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getStatus()
    {
        return $this->hasOne(Status::className(), ['id' => 'statusId']);
    }

	/**
	 * @return \yii\db\ActiveRecord
	 */
	public function getLastMStatus()
	{
		return $this->getMStatuses()->orderBy('created_at')->one();
	}

	/**
	 * @return yii\db\ActiveQuery
	 */
	public function getMStatuses()
	{
		return $this->hasMany(MuseumStatus::className(), ['museum_id' => 'id']);
	}

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getExpert()
    {
	    return $this->hasOne(User::className(), ['id' => 'expertId']);
    }

    public function getLastFileName()
    {
        $lastFile = $this->lastFile;

        return $lastFile ? $lastFile->filename : '';
    }

    public function getStatusName()
    {
        $status = $this->status;

        return $status ? $status->name : '';
    }

    public function getAdditionalName()
    {
        return ArrayHelper::getValue(self::getAdditionalList(), $this->additional, null);
    }

    public static function getAdditionalList()
    {
        return [
            1 => 'Дошкольники',
            2 => 'ОВЗ',
            3 => 'Дошкольники + ОВЗ'
        ];
    }

    public static function getStatusList()
    {
        return array_flip(ArrayHelper::getColumn(Status::find()->orderBy('name')->all(),'name'));
    }

	public function afterSave($insert, $changedAttributes)
	{
		if(isset($changedAttributes['statusId']) || $insert){
			$museumStatus = new MuseumStatus([
				'status_id' => $this->statusId,
				'museum_id' => $this->id
			]);
			$museumStatus->save();
		}
		parent::afterSave($insert, $changedAttributes);
	}
}

controllers/MuseumController.php
<?php

namespace app\controllers;

use yii;
use yii\web\Response;
use app\models\Status;
use app\models\search\MuseumSearch;
use app\models\search\MuseumOwnSearch;
use app\models\File;
use app\models\Museum;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * MuseumController implements the CRUD actions for Museum model.
 */
class MuseumController extends Controller
{
    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Museum models.
     * @return mixed
     */
    public function actionIndex()
    {
	    if(!Yii::$app->user->can('museumIndex')){
		    return $this->redirect(['expert'], 302);
	    }

        $searchModel = new MuseumSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
	        'statuses' => Status::find()->indexBy('id')->orderBy('id')->all(),
        ]);
    }

	/**
	 * Lists all Museum models for expert.
	 * @return mixed
	 */
	public function actionExpert()
	{
		if(!Yii::$app->user->can('museumExpert')){
			return $this->redirect(['site/login'], 302);
		}

		$searchModel = new MuseumOwnSearch();
		$dataProvider = $searchModel->search(Yii::$app->request->queryParams);

		return $this->render('expert', [
			'searchModel' => $searchModel,
			'dataProvider' => $dataProvider,
		]);
	}

    /**
     * Displays a single Museum model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
	    $museum = $this->findModel($id);

	    if(!Yii::$app->user->can('museumView', ['museum' => $museum])){
		    return $this->redirect(['index'], 302);
	    }

        return $this->render('view', [
            'model' => $museum,
        ]);
    }

    /**
     * Creates a new Museum model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
	    if(!Yii::$app->user->can('museumCreate')){
		    return $this->redirect(['index'], 302);
	    }

        $model = new Museum();
		$file = new File();
	    $file->loadFiles();
        if ($model->load(Yii::$app->request->post()) && $model->save()) {
	        if($file->load(Yii::$app->request->post()) && $file->isWithFile()){
		        $file->museumId = $model->id;
		        if($file->save()){
			        return $this->redirect(['view', 'id' => $model->id]);
		        }
		        else{
			        return $this->render('create', [
				        'model' => $model,
				        'statuses' => Status::find()->indexBy('id')->orderBy('id')->all(),
				        'file' => $file,
			        ]);
		        }
	        }
	        else{
		        return $this->redirect(['view', 'id' => $model->id]);
	        }
        } else {
            return $this->render('create', [
                'model' => $model,
                'statuses' => Status::find()->indexBy('id')->orderBy('id')->all(),
	            'file' => $file,
            ]);
        }
    }

    /**
     * Updates an existing Museum model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

	    if(!Yii::$app->user->can('museumUpdate')){
		    return $this->redirect(['index'], 302);
	    }

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('update', [
                'model' => $model,
                'statuses' => Status::find()->indexBy('id')->orderBy('id')->all(),
            ]);
        }
    }

	public function actionAjaxUpdate( ){
		if(!Yii::$app->user->can('museumUpdate')){
			\Yii::$app->response->format = Response::FORMAT_JSON;
			return ['output' => '', 'message' => 'Недостаточно прав'];
		}

		if (isset($_POST['hasEditable'])) {

			\Yii::$app->response->format = Response::FORMAT_JSON;

			if(!isset(Yii::$app->request->post('Museum')['id'])){
				return ['output' => '', 'message' => ''];
			}
/*
			ob_start();
			var_dump(Yii::$app->request->post('Museum'));
			return ['output' => '', 'message' => ob_get_clean()];*/

			$museumId = Yii::$app->request->post('Museum')['id'];

			/** @var Museum $museum */
			$museum = Museum::findOne(['id'=>$museumId]);
			$museum->load(Yii::$app->request->post());
			if( $museum->save() ) {
				$value = $museum->statusName;
				return ['output' => $value, 'message' => ''];
			}
			else{
				$errors = $museum->getFirstErrors();
				$string = 'Ошибки:';
				foreach ( $errors as $attribute => $error){
					$string.= "$attribute - $error; ";
				}
				return ['output' => '', 'message' => $string];
			}
		}

		return true;
	}

    /**
     * Deletes an existing Museum model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
	    if(!Yii::$app->user->can('museumDelete')){
		    return $this->redirect(['index'], 302);
	    }

        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Museum model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Museum the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Museum::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}

views/museum/_form.php
<?php

use app\models\Status;
use app\models\User;
use app\models\File;
use app\models\Museum;
use yii\helpers\Html;
use yii\helpers\ArrayHelper;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Museum */
/* @var $form yii\widgets\ActiveForm */
/* @var $statuses Status[]*/
$file = new File;
?>

<div class="museum-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'name')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'statusId')->dropDownList(ArrayHelper::getColumn( $statuses,'name')) ?>

    <?= $form->field($model, 'additional')->dropDownList(Museum::getAdditionalList(), ['prompt' => 'Ничего особенного']) ?>

    <?= $form->field($model, 'expertId')->dropDownList([null=>'Пусто']+ArrayHelper::getColumn( User::find()->indexBy('id')->all(),'fullname')) ?>

	<?= $form->field($model, 'contacts')->textarea(['rows' => 5]) ?>

	<hr>

	<?if (isset($file)):?>

		Загрузите файл, али ссылку на ресурс заморский, ежели есть:

	<?=	$this->render('//file/_filePoles',
			[
				'form' => $form,
				'model' => $file,
			]);?>
	<?endif;?>

	<div class="form-group">
        <?= Html::submitButton($model->isNewRecord ? 'Добавить' : 'Сохранить', ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/museum/_info.php
<?php
use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $model \app\models\Museum */
?>

<?= DetailView::widget([
		'model' => $model,
		'attributes' => [
			'id',
			'name',
			[
				'attribute' => 'statusId',
				'value' => $model->statusName,
			],
			[
				'attribute' => 'expertId',
				'value' => $model->expert?$model->expert->fullName:null,
			],
			[
				'attribute' => 'contacts',
				'format' => 'ntext'
			],
            [
				'attribute' => 'additionalName',
                'format' => 'ntext'
			],
			[
				'attribute' => 'updated_at',
				'format' => ['date', 'php:Y-m-d H:i:s']
			],
			[
				'attribute' => 'created_at',
				'format' => ['date', 'php:Y-m-d H:i:s']
			],
		],
	]);?>

<p>
	<?= Html::a('Изменить', ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
	<?= Html::a('Удалить', ['delete', 'id' => $model->id], [
		'class' => 'btn btn-danger',
		'data' => [
			'confirm' => 'Вы уверены, что хотите удалить музей ' . $model->name . '?',
			'method' => 'post',
		],
	]) ?>
</p>

views/museum/_museumIndex.php
<?php

use app\models\Museum;
use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use kartik\editable\Editable;
use yii\helpers\ArrayHelper;
use yii\bootstrap\Collapse;

/* @var $this yii\web\View */
/* @var $museums yii\data\ActiveDataProvider */
/** @var array $statuses */
?>

<?= GridView::widget([
	'dataProvider' => $museums,
	'formatter' => ['class' => 'yii\i18n\Formatter','nullDisplay' => 'Отсутствует'],
	'columns' => [
		['class' => 'yii\grid\SerialColumn'],
		[
			'attribute' => 'id',
			'contentOptions'=>['style'=>'width: 60px;'],
		],
		'name',
//        [
//            'attribute' => 'statusName',
//            'label' => 'Статус',
//            'format' => 'text', // Возможные варианты: raw, html
//            'value' => 'status.name',
//        ],
//		[
//			'attribute' => 'lastFileName',
//			'label' => 'Файлы',
//			'format' => 'raw',
//			'value' => function(Museum $museum) {
//				$out = [];
//				if ($museum->lastFile) {
//					$out[] = 'Крайний файл:'.$this->render('//file/_link', [
//							'model' => $museum->lastFile,
//						]);
//				}
//				$out[] = Html::a('Загрузить',Url::to(['file/create_for_museum', 'id' => $museum->id]));
//				$out[] = Html::a('ПросмотретьВсе',Url::to(['file/index_for_museum', 'id' => $museum->id]));
//				return implode("\n", $out);
//			},
//		],
	],
]); ?>

views/museum/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model app\models\Museum */
/* @var array $statuses */

$this->title = 'Добавить музеи';
$this->params['breadcrumbs'][] = ['label' => 'Музеи', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="museum-create">

    <h1><?= Html::encode($this->title) ?></h1>

	<?= isset($error) ? $error : 'Ошибок нет'?>
    <?= $this->render('_form', [
        'model' => $model,
        'statuses' => $statuses,
	    'file' => $file,
    ]) ?>

</div>

views/museum/expert.php
<?php

use app\models\Museum;
use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use app\models\File;
use yii2mod\comments\widgets\LastComment;

/* @var $this yii\web\View */
/* @var $searchModel app\models\search\MuseumSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Музеи';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="museum-index">

	<h1><?= Html::encode($this->title) ?></h1>

	<?php if(Yii::$app->user->can('museumCreate')):?>
		<p>
			<?= Html::a('Добавить музей', ['create'], ['class' => 'btn btn-success']) ?>
		</p>
	<?php endif;?>
	<?= GridView::widget([
		'dataProvider' => $dataProvider,
		'filterModel' => $searchModel,
		'formatter' => ['class' => 'yii\i18n\Formatter','nullDisplay' => 'Отсутствует'],
		'columns' => [
			//['class' => 'yii\grid\SerialColumn'],
			'id',
			[
				'attribute' => 'name',
				'label' => 'Название',
				'format' => 'raw',
				'value' => function(Museum $museum) {
					return Html::a($museum->name, Url::to(['museum/view', 'id' => $museum->id]),['target'=>'_blank']);
				},
			],
			[
				'attribute' => 'lastFileName',
				'label' => 'Крайний файл',
				'format' => 'raw',
				'value' => function(Museum $museum) {
					if(is_null($museum->lastFile)){
						return 'Файл отсутствует';
					}
					if(!Yii::$app->user->can('fileDownload',[
						'museum' => $museum,
						'file' => $museum->lastFile,
					])){
						return 'Скачивание заблокировано.';
					}
					if ($museum->lastFile){
						return $this->render('//file/_link', [
							'model' => $museum->lastFile,
						]);
					}
					return null;
				},
			],
			[
				'label' => 'Последний комментарий',
				'format' =>'raw',
				'value' => function(Museum $museum){
					return LastComment::widget([
						'model' => $museum,
						'relatedTo' => 'User ' . \Yii::$app->user->identity->fullname . ' commented on the page ' . Url::current(), // for example
						'perPage' => null
					]);
				},
				//'contentOptions'=>['style'=>'width: 300px;'],
			],
//            [
//                'attribute' => 'statusName',
//                'label' => 'Статус',
//                'format' => 'text', // Возможные варианты: raw, html
//                'value' => 'status.name',
//            ],
			[
				'attribute' => 'loadFileName',
				'label' => 'Загрузить файл',
				'format' => 'raw', // Возможные варианты: raw, html
				'value' => function(Museum $museum){
					if(!Yii::$app->user->can('fileCreate',[
						'museum' => $museum,
					])){
						return 'Загрузка заблокирована.';
					}
					$file = new File();
					$file->loadMuseum($museum);
					return $this->render('//file/_form_for_museum',['model'=>$file]);
				}
			],
		],
	]); ?>
</div>

views/museum/index.php
<?php

use app\models\Museum;
use yii\helpers\Html;
use kartik\grid\GridView;
use yii\helpers\Url;
use app\models\File;
use kartik\editable\Editable;
use yii\helpers\ArrayHelper;
use yii\bootstrap\Collapse;
use \yii2mod\comments\widgets\LastComment;

/* @var $this yii\web\View */
/* @var $searchModel app\models\search\MuseumSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */
/** @var array $statuses */



$this->title = 'Музеи';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="museum-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Добавить музей', ['create'], ['class' => 'btn btn-success']) ?>
    </p>

    <?= GridView::widget([
	    'floatHeader'=>true,
	    'floatHeaderOptions'=>['position' => 'auto','top'=>50],
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
	    'formatter' => ['class' => 'yii\i18n\Formatter','nullDisplay' => 'Отсутствует'],
        'columns' => [
            //['class' => 'yii\grid\SerialColumn'],
            [
	            'attribute' => 'id',
	            'contentOptions'=>['style'=>'width: 60px;'],
            ],
	        [
		        'attribute' => 'name',
		        'label' => 'Название',
		        'format' => 'raw',
		        'value' => function(Museum $museum) {
			        return Html::a($museum->name, Url::to(['museum/view', 'id' => $museum->id]),['target'=>'_blank']);
		        },
	        ],
//            [
//                'attribute' => 'statusName',
//                'label' => 'Статус',
//                'format' => 'text', // Возможные варианты: raw, html
//                'value' => 'status.name',
//            ],
	        [
		        'attribute' => 'statusName',
		        'label' => 'Статус',
		        'format' => 'raw', // Возможные варианты: raw, html
		        'value' => function(Museum $museum) use ($statuses){
			        return Editable::widget([
				        'id' => $museum->id . 'editableWidget',
				        'formOptions' => [
					        'action' => Url::to(['museum/ajax-update']),
				        ],
				        'model' => $museum,
				        'displayValue' => $museum->statusName,
				        'attribute' => 'statusId',
				        'name'=>'Статус',
				        'asPopover' => true,
				        'header' => 'Статус',
				        'format' => Editable::FORMAT_BUTTON,
				        'inputType' => Editable::INPUT_DROPDOWN_LIST,
				        'data'=> ArrayHelper::getColumn($statuses, 'name'),
				        'options' => ['class'=>'form-control', 'prompt'=>'Выберете статус', 'id'=>uniqid('museumStatus')],
				        'beforeInput' => Html::hiddenInput('Museum[id]', $museum->id ),
			        ]);
		        }
	        ],
            [
		        'attribute' => 'additionalName',
		        'label' => 'Доп. инфо',
                'filter' => Museum::getAdditionalList()
	        ],
	        [
		        'attribute' => 'expertFullname',
		        'label' => 'Эксперт',
		        'format' => 'text', // Возможные варианты: raw, html
		        'value' => 'expert.fullname',
	        ],
	        [
		        'attribute' => 'lastFileName',
		        'label' => 'Файлы',
		        'format' => 'raw',
		        'value' => function(Museum $museum) {
			        $out = [];
			        if ($museum->lastFile) {
				        $out[] = 'Крайний файл:'.$this->render('//file/_link', [
					        'model' => $museum->lastFile,
				        ]);
		            }
			        $out[] = Html::a('Загрузить',Url::to(['file/create_for_museum', 'id' => $museum->id]),['target'=>'_blank']);
			        $out[] = Html::a('ПросмотретьВсе',Url::to(['file/index_for_museum', 'id' => $museum->id]),['target'=>'_blank']);
			        return implode("\n", $out);
		        },
	        ],
	        [
		        'label' => 'Последний комментарий',
		        'format' =>'raw',
		        'value' => function(Museum $museum){
			        return LastComment::widget([
				        'model' => $museum,
				        'relatedTo' => 'User ' . \Yii::$app->user->identity->fullname . ' commented on the page ' . Url::current(), // for example
				        'perPage' => null
			        ]);
		        },
		        //'contentOptions'=>['style'=>'width: 300px;'],
	        ],
	        [
		        'attribute' => 'updated_at',
		        'format' => ['date', 'php:Y-m-d H:i:s']
	        ],
//	        [
//		        'attribute' => 'created_at',
//		        'format' => ['date', 'php:Y-m-d H:i:s']
//	        ],
            ['class' => 'yii\grid\ActionColumn',],
			[
				'attribute' => 'contacts',
				'format' => 'ntext'
			],
        ],
    ]); ?>
</div>

views/museum/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Museum */

$this->title = 'Изменить музей ' . $model->name;
$this->params['breadcrumbs'][] = ['label' => 'Музеи', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->name, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = 'Изменение';
?>
<div class="museum-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
        'statuses' => $statuses,
    ]) ?>

</div>

views/museum/view.php
<?php

use app\models\search\FileSearch;
use yii\helpers\Html;
use app\modules\logger\loggerWidget;
use kartik\tabs\TabsX;
use yii\helpers\Url;
use yii2mod\comments\widgets\Comment;
use app\models\User;
use yii\data\ActiveDataProvider;

/* @var $this yii\web\View */
/* @var $model app\models\Museum */

$this->title = $model->name;
$this->params['breadcrumbs'][] = ['label' => 'Музеи', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="museum-view">

    <h1><?= Html::encode($this->title) ?></h1>

	<?php
	$tabs = [];
	$tabs[] = [
		'label'=>'<i class="glyphicon glyphicon-info-sign"></i> О музее',
		'content'=> $this->render('_info',['model'=>$model]),
		//'linkOptions'=>['data-url'=>Url::to(['/site/fetch-tab?tab=2'])]
		'active'=>true,
	];
	if(Yii::$app->user->can('museumLog')) {
		$tabs[] = [
			'label' => '<i class="glyphicon glyphicon-list"></i> Логи',
			'content' => loggerWidget::widget([
				'object' => $model,
				'userId' => Yii::$app->user->id,
			]),
			//'linkOptions'=>['data-url'=>Url::to(['/site/fetch-tab?tab=1'])]
		];
	}
	if(Yii::$app->user->can('museumHistory')) {
		$tabs[] = [
			'label' => '<i class="glyphicon glyphicon-piggy-bank"></i> История статусов',
			'content' => $this->render(
				'//status-history/_museum-history',
				[
					'dataProvider'=> new ActiveDataProvider([
						'query' => $model->getMStatuses()->orderBy('created_at DESC')]),
					'users'=>User::find()->indexBy('id')->all()
				])];
	}
	if(Yii::$app->user->can('fileIndex')) {
		$searchModel = new FileSearch();
		$dataProvider = $searchModel->search(Yii::$app->request->queryParams, $model->id);
		$tabs[] = [
			'label' => '<i class="glyphicon glyphicon-file"></i> Файлы',
			'content' => $this->renderAjax('//file/index_for_museum', [
				'searchModel' => $searchModel,
				'dataProvider' => $dataProvider,
			])];
	}
	$tabs[] = [
		'label'=>'<i class="glyphicon glyphicon-comment"></i> Комментарии',
		'content'=> Comment::widget([
			'model' => $model,
			'relatedTo' => 'User ' . \Yii::$app->user->identity->fullname . ' commented on the page ' . Url::current(), // for example
			'perPage' => null
		]),
		//'linkOptions'=>['data-url'=>Url::to(['/site/fetch-tab?tab=1'])]
	];
	?>

	<?= TabsX::widget([
		'items'=> $tabs,
		'position'=>TabsX::POS_ABOVE,
		'encodeLabels'=>false
	]);?>

</div>